org.apache.tinkerpop.gremlin.structure.io.binary

## Class GraphBinaryWriter

- java.lang.Object
- - org.apache.tinkerpop.gremlin.structure.io.binary.GraphBinaryWriter

-     public class GraphBinaryWriter
      extends Object

  Writes a value to a buffer using the `TypeSerializer` instances configured in the `TypeSerializerRegistry`.

  This class exposes two different methods to write a value to a buffer: `write(Object, Buffer)` and `writeValue(Object, Buffer, boolean)`:

  - `write()` method writes the binary representation of the `{type_code}{type_info}{value_flag}{value}` components.
  - `writeValue()` method writes the `{value_flag}{value}` when a value is nullable and only `{value}` when a value is not nullable.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static byte` | `VERSION_BYTE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GraphBinaryWriter()`
    `GraphBinaryWriter(TypeSerializerRegistry registry)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `<T> void` | `write(T value, Buffer buffer)` Writes an object in fully-qualified format, containing {type_code}{type_info}{value_flag}{value}.
    `<T> void` | `writeFullyQualifiedNull(Class<T> objectClass, Buffer buffer, Object information)` Represents a null value of a specific type, useful when the parent type contains a type parameter that must be specified.
    `<T> void` | `writeValue(T value, Buffer buffer, boolean nullable)` Writes a value without including type information.
    `void` | `writeValueFlagNone(Buffer buffer)` Writes a single byte with value 0, representing an unset value_flag.
    `void` | `writeValueFlagNull(Buffer buffer)` Writes a single byte representing the null value_flag.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### VERSION_BYTE

          public static final byte VERSION_BYTE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### GraphBinaryWriter

          public GraphBinaryWriter()

    - #### GraphBinaryWriter

          public GraphBinaryWriter(TypeSerializerRegistry registry)

  - ### Method Detail

    - #### writeValue

          public <T> void writeValue(T value,
                                     Buffer buffer,
                                     boolean nullable)
                              throws IOException

      Writes a value without including type information.
      Throws:
        `IOException`

    - #### write

          public <T> void write(T value,
                                Buffer buffer)
                         throws IOException

      Writes an object in fully-qualified format, containing {type_code}{type_info}{value_flag}{value}.
      Throws:
        `IOException`

    - #### writeFullyQualifiedNull

          public <T> void writeFullyQualifiedNull(Class<T> objectClass,
                                                  Buffer buffer,
                                                  Object information)
                                           throws IOException

      Represents a null value of a specific type, useful when the parent type contains a type parameter that must be specified.

      Note that for simple types, the provided information will be `null`.

      Throws:
        `IOException`

    - #### writeValueFlagNull

          public void writeValueFlagNull(Buffer buffer)

      Writes a single byte representing the null value_flag.

    - #### writeValueFlagNone

          public void writeValueFlagNone(Buffer buffer)

      Writes a single byte with value 0, representing an unset value_flag.

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.